#pragma once
#include <tec/TecFrame.h>
#include <list>

enum class ValueType { Int, Float };
enum class Direction { Read, Write };
struct ParameterDescriptor {
  /// Base name of the process varable (aka DOOCS property), without ".RD", ".RW" suffix etc.
  std::string pvName;

  /// TecParameter identifier for the hardware protocol
  TecFrame::TecParameter value;

  /// Value type
  ValueType valueType;

  /// Direction
  Direction direction;

  /// Engineering unit
  std::string unit;

  /// Parameter desccription
  std::string description;

  /// Base name of the process variable for the read-group command
  std::string readGroup;

  /// Base name of the process variable for the write-group command, empty for Direction::Read
  std::string writeGroup;

  /// Base name of the process variable for the write-to-flash-group command, empty for Direction::Read
  std::string writeToFlashGroup;

  /// Base name of the proess variable for the set-from-readback-group command, empty for Direction::Read
  std::string setFromReadbackGroup;
};

static std::list<ParameterDescriptor> descriptors{

    {"SOME_PV", TecFrame::TecParameter::MonSinkTemperature, ValueType::Float, Direction::Read, "unit", "description",
        "MY_READ_GROUP", "", "", ""},
    {"ANOTHER_PV", TecFrame::TecParameter::MonSinkTemperature, ValueType::Float, Direction::Read, "unit", "description",
        "MY_READ_GROUP", "", "", ""},
    {"THIRD_PV", TecFrame::TecParameter::MonSinkTemperature, ValueType::Float, Direction::Read, "unit", "description",
        "MY_READ_GROUP", "", "", ""}

};
