#pragma once

#include <ChimeraTK/DummyBackend.h>
#include <ChimeraTK/BackendFactory.h>
#include <ChimeraTK/DummyRegisterAccessor.h>

struct TecDummy : ChimeraTK::DummyBackend {
  TecDummy(std::string mapFileName) : DummyBackend(mapFileName) {}
  ~TecDummy() override {}

  // hardcoded addresses used by the dummy, need to match addresses of map file
  constexpr static uint8_t TecDummy_bar{0};
  constexpr static uint32_t TecDummy_address_loopDone{8};

  // Accessors for the registers
  ChimeraTK::DummyRegisterAccessor<uint32_t> reg_loopStart{this, "UNIO0", "BIT_TEC1091_CMD_LOOP_START"};
  ChimeraTK::DummyRegisterAccessor<uint32_t> reg_loopDone{this, "UNIO0", "BIT_TEC1091_CMD_LOOP_DONE"};
  ChimeraTK::DummyRegisterAccessor<uint32_t> reg_command{this, "UNIO0", "AREA_TEC1091_CMD"};

  static boost::shared_ptr<DeviceBackend> createInstance(std::string, std::map<std::string, std::string> parameters) {
    return boost::shared_ptr<DeviceBackend>(new TecDummy(parameters["map"]));
  }

  void read(uint8_t bar, uint32_t address, int32_t* data, size_t sizeInBytes) override;

  // In this function the TEC device is actually simulated.
  std::string processFrame(const std::string& command);

  class BackendRegisterer {
   public:
    BackendRegisterer();
  };
  static BackendRegisterer backendRegisterer;
};
